using System;
using System.Data;
using System.Windows.Forms;

using DevExpress.XtraCharts;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ε óϱ - Form_Load(sender, e)

        /// <summary>
        ///  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Form_Load(object sender, EventArgs e)
        {
            ChartControl chartControl = new ChartControl();

            chartControl.SeriesDataMember                  = "Month";
            chartControl.SeriesTemplate.ArgumentDataMember = "Section";

            chartControl.SeriesTemplate.ValueDataMembers.AddRange(new string[] { "Value" });

            chartControl.SeriesTemplate.View = new SideBySideBarSeriesView();

            chartControl.BoundDataChanged += chartControl_BoundDataChanged;

            chartControl.SeriesNameTemplate.BeginText = "Month : ";

            chartControl.Dock = DockStyle.Fill;

            Controls.Add(chartControl);

            chartControl.DataSource = GetChartControlData();
        }

        #endregion
        #region Ʈ Ʈ ε   óϱ - chartControl_BoundDataChanged(sender, e)

        /// <summary>
        /// Ʈ Ʈ ε   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void chartControl_BoundDataChanged(object sender, EventArgs e)
        {
            ChartControl chartControl = sender as ChartControl;

            Series februarySeries = chartControl.GetSeriesByName("Month : Feb");

            if(februarySeries != null)
            {
                februarySeries.ChangeView(ViewType.Line);
            }

            Series marchSeries = chartControl.GetSeriesByName("Month : March");

            if(marchSeries != null)
            {
                marchSeries.ChangeView(ViewType.Spline);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region Ʈ Ʈ  ϱ - GetChartControlData()

        /// <summary>
        /// Ʈ Ʈ  ϱ
        /// </summary>
        /// <returns>Ʈ Ʈ </returns>
        private DataTable GetChartControlData()
        {
            DataTable table = new DataTable("Table1");

            table.Columns.Add("Month"  , typeof(string));
            table.Columns.Add("Section", typeof(string));
            table.Columns.Add("Value"  , typeof(int   ));

            table.Rows.Add(new object[] { "Jan"  , "Section1", 10  });
            table.Rows.Add(new object[] { "Jan"  , "Section2", 20  });
            table.Rows.Add(new object[] { "Jan"  , "Section3", 40  });
            table.Rows.Add(new object[] { "Feb"  , "Section1", 20  });
            table.Rows.Add(new object[] { "Feb"  , "Section2", 30  });
            table.Rows.Add(new object[] { "Feb"  , "Section3", 80  });
            table.Rows.Add(new object[] { "March", "Section1", 30  });
            table.Rows.Add(new object[] { "March", "Section2", 40  });
            table.Rows.Add(new object[] { "March", "Section3", 100 });

            return table;
        }

        #endregion
    }
}